/*2:*/
#line 8 "./test-it.w"

#include <stdlib.h> 
#include <stdio.h> 
#include <string.h> 
#include <unistd.h> 
#include <curl/curl.h> 
#include "qt-part.h"
/*3:*/
#line 47 "./test-it.w"

struct global_data{
CURLM*curl;
int handles;
int*io_channel_counter;
};

/*:3*/
#line 15 "./test-it.w"

/*11:*/
#line 218 "./test-it.w"

void close_io_channel(int*io_channel_counter);

/*:11*/
#line 16 "./test-it.w"

/*7:*/
#line 95 "./test-it.w"

static void socket_cb(CURL*c,curl_socket_t fd,int action,
void*inf,void*priv);
static void io_socket_cb(void*iof,void*cb_vp,int fd);
static size_t incoming_list(void*dat,size_t len,size_t n,void*req_vp);


/*:7*/
#line 17 "./test-it.w"

/*16:*/
#line 269 "./test-it.w"


/*13:*/
#line 232 "./test-it.w"

struct url_opdat{
struct global_data*global;
char*url;
};
struct socket_opdat{
struct global_data*global;
void*out_iof,*in_iof;
};

/*:13*/
#line 271 "./test-it.w"

/*14:*/
#line 243 "./test-it.w"

extern void setup_curl_multi_urls(struct global_data*global,
const char*base_url);
extern void*setup_curl_url(struct global_data*global,const char*url);



/*:14*/
#line 272 "./test-it.w"


/*17:*/
#line 278 "./test-it.w"

struct test_read_data{
char*some_fd_context;
int status;
int*io_channel_counter;
};

/*:17*/
#line 274 "./test-it.w"

/*18:*/
#line 286 "./test-it.w"

extern void test_read_cb(void*iof,void*dat,int fd);

/*:18*/
#line 275 "./test-it.w"


/*:16*/
#line 18 "./test-it.w"

int main(int argc,char**argv)
{
int io_channel_counter= 0;

struct global_data global;
struct test_read_data*trd= calloc(1,sizeof(struct test_read_data));
int code;

curl_global_init(CURL_GLOBAL_ALL);
create_test_app();

trd->io_channel_counter= &io_channel_counter,io_channel_counter++;
create_io_channel(0,0,trd,test_read_cb);

global.curl= curl_multi_init();
global.io_channel_counter= &io_channel_counter;io_channel_counter++;
setup_curl_multi_urls(&global,"http://curl.haxx.se/download");

while(CURLM_CALL_MULTI_PERFORM==
(code= curl_multi_socket_all(global.curl,&global.handles)));

exec_test_app();
if(trd->some_fd_context)free(trd->some_fd_context);
curl_multi_cleanup(global.curl);
return 0;
}

/*:2*//*5:*/
#line 57 "./test-it.w"

void*setup_curl_url(struct global_data*global,const char*url)
{
CURL*curl= curl_easy_init();
struct url_opdat*url_dat= calloc(1,sizeof(struct url_opdat));
url_dat->global= global;
url_dat->url= malloc(strlen(url)+1);
strcpy(url_dat->url,url);
curl_easy_setopt(curl,CURLOPT_WRITEFUNCTION,incoming_list);
curl_easy_setopt(curl,CURLOPT_HEADERFUNCTION,incoming_list);
curl_easy_setopt(curl,CURLOPT_WRITEDATA,url_dat);
curl_easy_setopt(curl,CURLOPT_HEADERDATA,url_dat);
curl_easy_setopt(curl,CURLOPT_NOBODY,1);
curl_easy_setopt(curl,CURLOPT_URL,url);
return curl;

}

/*:5*//*6:*/
#line 76 "./test-it.w"

void setup_curl_multi_urls(struct global_data*global,const char*base_url)
{
char url_buf[1024];
unsigned i;
CURL*curl;

for(i= 0;i<25;++i){
sprintf(url_buf,"%s/curl-7.%d.0.tar.bz2",base_url,i);
curl= setup_curl_url(global,url_buf);
if(curl!=NULL){
curl_multi_add_handle(global->curl,curl);
}
}
curl_multi_setopt(global->curl,CURLMOPT_SOCKETFUNCTION,socket_cb);
curl_multi_setopt(global->curl,CURLMOPT_SOCKETDATA,global);
}

/*:6*//*8:*/
#line 104 "./test-it.w"

void socket_cb(CURL*c,curl_socket_t fd,int action,
void*inf,void*priv)
{
struct socket_opdat*dat= priv;
struct global_data*global= inf;
#if DEBUG_HANDLES
fprintf(stdout,"CURL SOCKET CB %d",fd);
#endif
if(dat==NULL){
dat= calloc(1,sizeof(struct socket_opdat));
dat->global= global;
curl_multi_assign(global->curl,fd,dat);
}
switch(action){
case CURL_POLL_NONE:
#if DEBUG_HANDLES
fprintf(stdout," NONE\n");
#endif
break;
case CURL_POLL_IN:
#if DEBUG_HANDLES
fprintf(stdout," IN %p\n",dat);
#endif
if(dat->out_iof)destroy_io_channel(&dat->out_iof);
if(!dat->in_iof)
dat->in_iof= create_io_channel(fd,0,
dat,io_socket_cb);
break;
case CURL_POLL_OUT:
#if DEBUG_HANDLES
fprintf(stdout," OUT %p\n",dat);
#endif
if(dat->in_iof)destroy_io_channel(&dat->in_iof);
if(!dat->out_iof)
dat->out_iof= create_io_channel(fd,1,
dat,io_socket_cb);
break;
case CURL_POLL_INOUT:
#if DEBUG_HANDLES
fprintf(stdout," INOUT %p\n",dat);
#endif
if(!dat->out_iof)
dat->out_iof= create_io_channel(fd,1,dat,
io_socket_cb);
if(!dat->in_iof)
dat->in_iof= create_io_channel(fd,0,dat,
io_socket_cb);
break;
case CURL_POLL_REMOVE:
#if DEBUG_HANDLES
fprintf(stdout," REMOVE %p\n",dat);
#endif
if(dat->out_iof)destroy_io_channel(&dat->out_iof);
if(dat->in_iof)destroy_io_channel(&dat->in_iof);
if(dat!=NULL)free(dat);
break;
default:
#if DEBUG_HANDLES
fprintf(stdout," unkown\n");
#endif
break;
}
}

/*:8*//*9:*/
#line 170 "./test-it.w"

void io_socket_cb(void*iof,void*dat_vp,int fd)
{
struct socket_opdat*dat= dat_vp;
struct global_data*global= dat->global;
int code;
while(CURLM_CALL_MULTI_PERFORM==
(code= curl_multi_socket_action(global->curl,
fd,0,&global->handles)));
if(global->handles==0){
close_io_channel(global->io_channel_counter);
}
}

/*:9*//*10:*/
#line 185 "./test-it.w"

size_t incoming_list(void*dat,size_t len,size_t n,void*req_vp)
{
struct url_opdat*url_dat= req_vp;
char*buf;
buf= malloc(len*n+1);
memcpy(buf,dat,len*n);
buf[len*n]= '\0';
if(len*n<5){free(buf);return len*n;}
if(memcmp(buf,"HTTP/",5)==0){
unsigned p= 6;
long http_code;
int ok= 0;
char*e;
while(buf[p]!=' '&&p<len*n)++p;
if(buf[p]==' '){
e= buf+p;
http_code= strtol(buf+p,&e,10);
if(e> buf+p&&e-buf<len*n){
if(e[0]==' ')ok= 1;
}
}
if(ok){
fprintf(stdout,"INCOMING[%s]:%ld\n",
url_dat->url,http_code);
}

}
free(buf);
return len*n;
}

/*:10*//*12:*/
#line 222 "./test-it.w"

void close_io_channel(int*io_channel_counter){
if(*io_channel_counter> 1)
(*io_channel_counter)--;
else
call_test_app_quit();
}


/*:12*//*15:*/
#line 251 "./test-it.w"

void test_read_cb(void*iof,void*dat,int fd)
{
char buf[1024];
struct test_read_data*trd= dat;
int nread= 0;
nread= read(fd,buf,1024);
if(nread<=0){
fprintf(stdout,"close on %d\n",fd);
destroy_io_channel(&iof);
close_io_channel(trd->io_channel_counter);
}
else
fprintf(stdout,"read %d bytes from %d\n",nread,fd);
trd->status= 0;
}

/*:15*/
